#ifndef FURNITURE_PROFILE_H
#define FURNITURE_PROFILE_H

#include <QString>
#include <QList>
#include <QMap>

class FurnitureProfile
{
public:
    FurnitureProfile(int, QString, QString, QString, int, QString, QString, QString, int, int, int);
    enum Type {
        NullType,
        SolidType,
        SitType,
        RugType,
        RollerType,
        PosterType,
        FloorType,
        DoorType,
        BedType
    };
    QString sprite;
    QString name;
    int sitheight, width, height, stack;
    QString var, cust, flag, typestr;
    Type type;
    inline Type getType(){return type;}
    inline int getID(){return id;}
    inline int getWidth(){return width;}
    inline int getHeight(){return height;}
    inline int getSitHeight(){return sitheight;}
    inline QString getVar(){return var;}
    inline QString getCust(){return cust;}
    inline QString getFlag(){return flag;}
    inline QString getTypeStr(){return typestr;}

    static void init();
    static FurnitureProfile* byID(int);
    static FurnitureProfile* bySprite(QString);


    inline static QString typeToString(Type t){
        switch(t){
            case SolidType:
                return "solid";
            case SitType:
                return "sit";
            case RugType:
                return "rug";
            case RollerType:
                return "roller";
            case PosterType:
                return "poster";
            case FloorType:
                return "floor";
            case DoorType:
                return "door";
            case BedType:
                return "bed";
            default:
                return "null";
        }
    }

    inline static Type typeFromString(QString string){
        return typemap.value(string.trimmed().toLower(), NullType);
    }

private:

    int id;

    static QList<FurnitureProfile*> db;

    static QMap<QString, FurnitureProfile*> dbstr;
    static QMap<QString, Type> typemap;
};

#endif // FURNITURE_H
